//+------------------------------------------------------------------+
//|                                             Ease of Movement.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_minimum -0.1
#property indicator_maximum 0.1
#property indicator_buffers 1
#property indicator_color1 Lime
//---- input parameters
extern int CountBars = 300;
extern int SmoothPeriods = 1;
//---- buffers
double EOMBuffer[];
double EMAS[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE,0,1,Lime);
   SetIndexBuffer(0,EOMBuffer);
   SetIndexBuffer(1,EMAS);
   SetIndexDrawBegin(0,Bars-CountBars);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i, k, counted_bars=IndicatorCounted();
   double EMV, midptM, boxR, MAS;
   if(CountBars<1)
      return(0);
   if(Bars<=CountBars)
      return(0);      
//---- initial zero
   if(counted_bars<0)
     {
      for(i=1;i<=CountBars;i++)
         EOMBuffer[Bars-i]=0.0;
     }      
   
//----check for possible errors
if(counted_bars<0) return(-1);
   
//----last counted bar will be recounted
if(counted_bars>0) counted_bars--;
//---- indicator calculation loop 
k = CountBars;  
while(k>0)
  {
   midptM = ((High[k]+Low[k])/2)-((High[k-1]+Low[k-1])/2);
   boxR = (Volume[k]/1000)/((High[k]-Low[k])*(1/Point));   
   EMV = midptM/boxR;
   EOMBuffer[k] = EMV;
   
   k--;
   
  }             
             
   return(0);
  }
//+------------------------------------------------------------------+